/*
    SaveAnim.rexx

    example save an IFF-animation to "Ram:" usin BuildAnim.

    Thanks to the author of BuildAnim:
    Christer Sundin (d8sunch@dtek.chalmers.se)

    Need command "RequestFile" (part of OS 3.0+).

     2002 Edgar Schwan

    $VER: SaveAnim.rexx 1.0 (13.2.2002)
*/

PARSE ARG portname ' ' .
IF portname = "" THEN
  ADDRESS FLASHMANDEL.1;
ELSE
  ADDRESS VALUE portname;

OPTIONS RESULTS;

IF ~SHOW('L','rexxsupport.library') THEN
   CALL ADDLIB('rexxsupport.library',0,-30);

AnimDir = "ram:"; AnimFName = "FlashMandelWOS.anim"
TempDir = "t:"; TempFName = "pic";
BuildAnimPath = "FLASHMANDEL:arexx/c/BuildAnim";
Fact = 1.1;
Loops = 10;

ADDRESS COMMAND
tmp = TempDir || 'animpath';
'c:RequestFile >' || tmp 'DRAWER=' || AnimDir 'FILE=' || AnimFName 'TITLE="Choose path of iff-animation" PUBSCREEN=' || portname
IF RC = 5 THEN EXIT 0
ELSE DO
  IF OPEN('path', tmp, 'R') THEN DO
    AnimPath = READLN('path');
    CALL CLOSE('path');
    END;
  END;
CALL DELETE(tmp);
ADDRESS;

'GET_SCREENATTRS DIMS';            /* get screen-dimension */
ZOOMWIDTH = Round(DIMS.WIDTH / Fact);
ZOOMHEIGHT = Round(DIMS.HEIGHT / Fact);
ZOOMLEFT = Round((DIMS.WIDTH - ZOOMWIDTH ) / 2.8);
ZOOMTOP = Round((DIMS.HEIGHT - ZOOMHEIGHT) / 2.8);

tmp = TempDir || TempFName || '.';

SAY "create temporary frames..."   /* create temporary frames */
DO I = 1 TO Loops
   'ZOOM' ZOOMLEFT ZOOMTOP ZOOMWIDTH ZOOMHEIGHT 1 1 'FAST';
   SAY "- frame" I || ", elapsed:" RESULT;
   'SAVE_PICTURE' tmp || I 'FORCE';
END I;

ADDRESS COMMAND;                   /* create animation */
ECHO ""; ECHO "create iff-animation...  (" || AnimPath || ")";
BuildAnimPath tmp || '1' AnimPath 'ANIM5';
ECHO "";

SAY "delete temporary frames..."   /* delete temporary frames */
DO I=1 TO Loops
   'delete' tmp || I;
END I;

ECHO "ready";                      /* ready */

EXIT 0;

/* round number */
Round:
PARSE ARG Number;
IF INDEX(Number, '.') ~= 0 THEN Number = LEFT(Number, (INDEX(Number, '.') - 1));
RETURN Number;

