/*
 * Show actual coordinates
 *
 *  20.2.2002 by Edgar Schwan
 */

PARSE ARG portname ' ' .
IF LENGTH(portname) = 0 THEN
    ADDRESS FLASHMANDEL.1;
ELSE
    ADDRESS VALUE portname;

OPTIONS RESULTS;
OPTIONS FAILAT 21;

IF ~SHOW('L','rexxsupport.library') THEN      /* load 'rexxsupport.library' */
   CALL ADDLIB('rexxsupport.library',0,-30);

/*TRACE INTERMEDIATES*/

OUTCON = "CON:10/10/300/200/Coordinates/SCREEN " || ADDRESS();

COORDS.RMIN = '-2.0';  /* Left */
COORDS.RMAX = '+1.5';  /* Top */
COORDS.IMIN = '+2.0';  /* Right */
COORDS.IMAX = '-1.5';  /* Bottom */
COORDS.JKRE = '+0.0';  /* Julia Real */
COORDS.JKIM = '+0.0';  /* Julia Imag */

IF OPEN('out', OUTCON, 'RW') THEN DO
  'GET_COORDINATES' 'COORDS'

  WRITELN('out', "  COORDS.RMIN: " COORDS.RMIN);
  WRITELN('out', "  COORDS.RMAX: " COORDS.RMAX);
  WRITELN('out', "  COORDS.IMIN: " COORDS.IMIN);
  WRITELN('out', "  COORDS.IMAX: " COORDS.IMAX);
  WRITELN('out', "  COORDS.JKRE: " COORDS.JKRE);
  WRITELN('out', "  COORDS.JKIM: " COORDS.JKIM);

  WRITELN('out', "");
  WRITELN('out', " <Please press a key>");
  READCH('out', 1);

  CLOSE('out');
  END

EXIT 0;
