/*
    PlayMovie.rexx

    example: do some zooms into the picture.

     2002 Edgar Schwan

    $VER: PlayMovie.rexx 1.0 (14.2.2002)
*/

PARSE ARG portname ' ' .
IF portname = "" THEN
  ADDRESS FLASHMANDEL.1;
ELSE
  ADDRESS VALUE portname;

OPTIONS RESULTS;
OPTIONS FAILAT 21

DEBUG = 0;
FACT = 1.1;
LOOPS = 1;
REPEATS = 5;
STEPS = 1;

DIMS.WIDTH = 640;
DIMS.HEIGHT = 480;
DIMS.DEPTH = 8;

'GET_SCREENATTRS' 'DIMS';              /* Get screen-dimensions */

IF DEBUG > 0 THEN DO
   SAY "WIDTH: " DIMS.WIDTH;
   SAY "HEIGHT: " DIMS.HEIGHT;
   SAY "DEPTH: "DIMS.DEPTH;
   END

ZOOMWIDTH = Round(DIMS.WIDTH / FACT);  /* calculate zoom-dimensions */
ZOOMHEIGHT = Round(DIMS.HEIGHT / FACT);
ZOOMLEFT = Round((DIMS.WIDTH - ZOOMWIDTH ) / 2.8);
ZOOMTOP = Round((DIMS.HEIGHT - ZOOMHEIGHT) / 2.8);

IF DEBUG > 0 THEN DO
   SAY "ZOOMLEFT: "ZOOMLEFT;
   SAY "ZOOMTOP: "ZOOMTOP;
   SAY "ZOOMWIDTH: "ZOOMWIDTH;
   SAY "ZOOMHEIGHT: "ZOOMHEIGHT;
   END;

DO I=1 TO LOOPS                        /* zoom */
   'ZOOM' ZOOMLEFT ZOOMTOP ZOOMWIDTH ZOOMHEIGHT REPEATS STEPS 'FAST';
   SAY "elapsed: " RESULT "RC2: " RC2;
END I;

EXIT 0;                                /* ready */

/* round number */
Round:
PARSE ARG Number;
IF INDEX(Number, '.') ~= 0 THEN Number = LEFT(Number, (INDEX(Number, '.') - 1));
RETURN Number;

